<?php
include "portal_admin.php";
session_start();

$portal = new PortalAdmin();
try{
  $portal->initDB("localhost", "php", "test", "testphp");
}
catch(Exception $e){
  //echo 'Brak połączenia z bazą danych.';
  //exit();
}

//Sprawdzenie czy jest parametr action.
if (isset($_GET['action'])) {
  $action = $_GET['action'];
}
else{
  $action = 'showMainAdmin';
}

//Wykonanie procedury logowania lub wylogowania.
switch($action):
  case 'login':
    if(!isset($_SESSION['zalogowany_adm']))
    switch($portal->login()){
      case LOGIN_OK:
        unset ($_SESSION['komunikat_adm']);
        break;
      case LOGIN_FAILED:
        $_SESSION['komunikat_adm'] = "Nieprawidłowa nazwa lub hasło!";
        break;
      case NO_ADMIN_RIGHTS:
        $_SESSION['komunikat_adm'] = "Brak uprawnień administracyjnych!";
        $portal->logout();
        break;
      case SERVER_ERROR:
      default:
        $_SESSION['komunikat_adm'] = "Błąd serwera!";
        $portal->logout();
    }
    break;
  case 'logout':
    $portal->logout();
    break;
  case 'subscriptionsAdmin':
    if(isset($_GET['wtd']) && $_GET['wtd'] == 'getEmailsList'){
      $portal->subscriptionsAdmin();
      return;
    }
    break;
endswitch;

//Ustalenie akcji dla niezalogowanego użytkownika.
if(!isset($_SESSION['zalogowany_adm'])){
  $action = 'showLoginForm';
}
?>
<!DOCTYPE html>
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<link rel="stylesheet" type="text/css" href="style.css">
<title>Portal (administracja)</title>
</head>
<body>
<div id="topDiv">
<?php if(isset($_SESSION['zalogowany_adm']) &&
         isset($_SESSION['zalogowany_adm']->przywileje[1])):
?>
<div id="headerDiv">
  Funkcje:
  <span class='headerLinks'>
  <?php echo $portal->getHeaderMenu(); ?>
  </span>
</div>
<?php
endif;
?>
<div id="mainContentDiv">
<?php
switch($action):
  case 'showLoginForm' :
    include 'adminLoginForm.php';
    break;
  case 'usersAdmin' :
    include 'usersAdminMenu.php';
    $portal->usersAdmin();
    break;
  case 'newsAdmin' :
    include 'newsAdminMenu.php';
    $portal->newsAdmin();
    break;
  case 'subscriptionsAdmin' :
    include 'subscriptionsAdminMenu.php';
    $portal->subscriptionsAdmin();
    break;
  case 'showMainAdmin':
  default:
?>
Wybierz z funkcję administracyjną z menu.
<?php
endswitch;
?>
</div>
</div>
</body>
</html>
